var Global_DP_InsertCoins = {
    dir: 'res/insert_coins/',
    layer: null,
    coin_box: null,
    slot_machine: null,
    coin_slot_pos: null
};

var DP_InsertCoinsLayer = cc.Layer.extend({
    callback: null,
    callbackTarget: null,
    ctor: function () {
        this._super();
        Global_DP_InsertCoins.layer = this;

        var bgColor = new cc.LayerColor(cc.color(0, 0, 0, 150));
        this.addChild(bgColor);

        this.addSlotMachine();
        this.addCoin();
        this.addCoinBox();
        // this.addBackButton();
        zAddBackButtonBegin(this);

        // showContentSize(this, cc.size(cc.winSize.width, cc.winSize.height));
    },
    addSlotMachine: function () {
        var dir = Global_DP_InsertCoins.dir;
        var slot_machine = zNewSpriteCreate(dir, 'slot_machine', this);
        var coin_slot_up = zNewSpriteCreate(dir, 'coin_slot_up', slot_machine);
        var coin_slot_dn = zNewSpriteCreate(dir, 'coin_slot_dn', slot_machine);
        slot_machine.setPosition(257.58, cc.winSize.height / 2);
        coin_slot_up.setPosition(324.40, 206.53);
        coin_slot_up.setGlobalZOrder(1);
        coin_slot_dn.setPosition(417.46, 206.53);
        Global_DP_InsertCoins.slot_machine = slot_machine;
        Global_DP_InsertCoins.coin_slot_pos = cc.p(417.46 + 40, 206.53);
        // zAddTouchLogPosEvent(slot_machine);
        // zAddTouchLogPosEvent(coin_slot_up);
        // zAddTouchLogPosEvent(coin_slot_dn);
    },
    addCoin: function () {
        var maskNode = new cc.ClippingNode();
        var drawNode = new cc.DrawNode();
        drawNode.drawRect(cc.p(0, 0), cc.p(300, cc.winSize.height), cc.color(255, 0, 0, 255), 0, cc.color(255, 0, 0, 255));
        maskNode.setStencil(drawNode);
        maskNode.setInverted(true);
        this.addChild(maskNode);

        var x0 = 714.69;
        var dx = 237.57;
        var y0 = cc.winSize.height / 2;
        var dy = 110;
        var coinPos = [
            cc.p(x0 + dx * 0, y0 + dy), cc.p(x0 + dx * 1, y0 + dy), cc.p(x0 + dx * 2, y0 + dy),
            cc.p(x0 + dx * 0.5, y0 - dy), cc.p(x0 + dx * 1.5, y0 - dy)
        ];
        var coins = [];
        for (var i = 0; i < 5; ++i) {
            var coin = zNewSpriteEventCreate(Global_DP_InsertCoins.dir, 'coin', maskNode,
                function (touch, target) {
                    zPauseTargetEvent(target);
                    var slot_machine = Global_DP_InsertCoins.slot_machine;
                    var coin_box = Global_DP_InsertCoins.coin_box;
                    var coin_slot_pos = Global_DP_InsertCoins.coin_slot_pos;
                    var pos = target.getPosition();
                    var endPos = zGetNodePosition(target.getParent(), slot_machine.convertToWorldSpace(coin_slot_pos));
                    var time = cc.pDistance(pos, endPos) / cc.winSize.width;
                    target.runAction(cc.sequence(
                        // cc.moveTo(0.5, 356.62,315.74),
                        // cc.bezierTo(0.8, [pos, cc.p((pos.x + 356.62) / 2, Math.max(pos.y, 315.74) + 100), cc.p(endPos)]).easing(cc.easeInOut(2)),
                        zGetBezierTo(time, pos, endPos).easing(cc.easeInOut(2)),
                        cc.moveBy(0.2, -target.width, 0)
                    ));
                    ddSound.playEffect('coin_insert');
                    coins.splice(coins.indexOf(target), 1);
                    coin_box.setCoinNumberNotSave(coin_box.getCoinNumber() - 1);
                    if (coins.length <= 0) {
                        // zLog('coin insert ok');
                        var layer = Global_DP_InsertCoins.layer;
                        layer.scheduleOnce(function () {
                            if (layer.callback && layer.callbackTarget) {
                                // coin_box.setCoinNumber(coin_box.getCoinNumber() - 5);
                                zSetLocalCoinNumber(coin_box.getCoinNumber());
                                layer.callback.call(layer.callbackTarget);
                            }
                            layer.removeFromParent(true);
                        }, 1);
                    }
                }, null, null, null);
            coin.setPosition(coinPos[i]);
            // zAddTouchLogPosEvent(coin);
            coins.push(coin);
        }
    },
    addCoinBox: function () {
        var coin_box = zAddCoinBox(this);
        // showContentSize(coinBox.getCoinBoxImage(), coinBox.getCoinBoxImage().getContentSize());
        Global_DP_InsertCoins.coin_box = coin_box;
    },
    setInsertOkCallBack: function (callback, callbackTarget) {
        this.callback = callback;
        this.callbackTarget = callbackTarget;
    }
});

var DP_InsertCoinsScene = cc.Scene.extend({
    ctor: function () {
        this._super();

        var layer = new DP_InsertCoinsLayer();
        this.addChild(layer);
    }
});


function zAddInsertCoinsLayer(parent, callback) {
    var layer = new DP_InsertCoinsLayer();
    layer.setLocalZOrder(1000);
    layer.setPosition(layer.convertToNodeSpace(cc.p(-cc.winSize.width / 2, -Global_DP.sinkY)));
    parent.addChild(layer);
    layer.setInsertOkCallBack(callback, parent);
}

function zSetLocalCoinNumber(number) {
    cc.sys.localStorage.setItem('CoinNumber', number);
}

function zGetLocalCoinNumber() {
    return cc.sys.localStorage.getItem('CoinNumber');
}